﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Winfoot_7_SDK;
using WinfootDefaultSystemPlugin.Controls.Strategy;

namespace WinfootDefaultSystemPlugin.Controls
{
    public partial class Jpn98FixPitch : UserControl,IControl,ICorrespondenceOS
    {
        private Jpn98FixPitchController jpn98FixPitchController;

        public Jpn98FixPitch()
        {
            InitializeComponent();
            CorrespondenceOSList = new List<OS>
                                       {
                                           OS.WindowsXP,
                                           OS.WindoesXP_SP1,
                                           OS.WindowsXP_SP2,
                                           OS.WindowsXP_SP3,
#if DEBUG
                                           OS.WindowsVista,
                                           OS.WindowsVista_SP1,
                                           OS.WindowsSeven
#endif
                                       };
        }

        private void groupBox1_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                UserHelp userHelp = new UserHelp(new Uri(@"http://www.google.co.jp/"));
                userHelp.Show();
            }
        }

        public void SetJpn98FixPitchState(bool b)
        {
            checkBox1.Checked = b;
        }


        public int GetJpn98FixPitchState()
        {
            if (checkBox1.Checked)
            {
                return 1;
            }
            return 0;
        }

        #region IControl メンバ

        public void Apply()
        {
            jpn98FixPitchController.Write();
        }

        public List<WFRegistry> BackUp()
        {
            return jpn98FixPitchController.BackUp();
        }

        #endregion

        #region ICorrespondenceOS メンバ

        public List<OS> CorrespondenceOSList { get; set; }

        #endregion

        private void Jpn98FixPitch_Load(object sender, EventArgs e)
        {
            WFUtillity wfUtillity = new WFUtillity();
            jpn98FixPitchController = new Jpn98FixPitchController(this,
                                                                        (IJpn98FixPitchStrategy)
                                                                        wfUtillity.
                                                                            GetCorrespondenceInstance
                                                                            (new List<ICorrespondenceOS>
                                                                                 {
                                                                                     new Jpn98FixPitchDefaultStrategy()
                                                                                 }));
            jpn98FixPitchController.Read();
        }
    }
}
